------------------------------------------------------------------
-- Info (Country, armies, owner): [(1, 2, 1), (2, 3, 2), (3, 1, 1)]
-- Borders (Country, Country): [(1, 2), (2, 3)]

-- ATENCION: Las funciones nombradas loqueseaMAP son utilizadas para
-- probar su funcionamiento de forma rapida. No son utiles para el juego
-- en general

------------------------------------------------------------------
-- Devuelve 1 si 2 territorios son frontera, 0 de lo contrario
------------------------------------------------------------------
tborder :: [(Integer, Integer)] -> Integer -> Integer -> Integer
tborder [] x y = 0
tborder ((a, b):xs) x y = if a == x && b == y then 1 else
				if a == y && b == x then 1 
				else tborder xs x y

tbordermap = tborder [(1, 2), (2, 3)]


------------------------------------------------------------------
-- Devuelve el propietario del terreno x
------------------------------------------------------------------
owner ((a, b, c):xs) x = if x == a then c else owner xs x
ownermap = owner [(1, 2, 1), (2, 3, 2), (3, 1, 1)]


------------------------------------------------------------------
-- Devuelve el numero de armies del terreno x
armies ((a, b, c):xs) x = if x == a then b else armies xs x
armiesmap = armies [(1, 2, 1), (2, 3, 2), (3, 1, 1)]

------------------------------------------------------------------
-- Encuentra territorio con menos armies de propietario x
------------------------------------------------------------------
lessarm [] x = 999999	-- Infinito
lessarm ((a, b, c):xs) x = if c==x && b <= lessarm xs x then b else lessarm xs x


lessarmies [] x = 0	-- Ninguno encontrado
lessarmies ((a, b, c):xs) x = if c==x && b <= lessarm xs x then a else lessarmies xs x

lessarmiesmap = lessarmies [(1, 2, 1), (2, 3, 2), (3, 1, 1)]


------------------------------------------------------------------
-- Encuentra territorio con mas armies de propietario x
------------------------------------------------------------------
morearm [] x = 0	-- Infinito
morearm ((a, b, c):xs) x = if c==x && b >= morearm xs x then b else morearm xs x


morearmies [] x = 0	-- Ninguno encontrado
morearmies ((a, b, c):xs) x = if c==x && b >= morearm xs x then a else morearmies xs x
morearmiesmap = morearmies [(1, 2, 1), (2, 3, 2), (3, 1, 1)]


------------------------------------------------------------------
-- Encuentra territorio con menos armies enemigo y con frontera x
------------------------------------------------------------------
lessarm2 [] x = 999999	-- Infinito
lessarm2 ((a, b, c):xs) x = if c==x && b < lessarm2 xs x then b else lessarm2 xs x

lessenemies [] x = 0	-- Ninguno encontrado
lessenemies ((a, b, c):xs) x = if tisfrontmap a x == 1 && b <= lessarm xs x then a else lessenemies xs x
lessenemiesmap = lessenemies [(1, 2, 1), (2, 3, 2), (3, 1, 1)]


------------------------------------------------------------------
-- Devuelve 1 si 2 territorios son frontera
------------------------------------------------------------------
tisfront borders info x y = if tborder borders x y == 1 && owner info x /= owner info y then 1 else 0
tisfrontmap = tisfront [(1, 2), (2, 3)] [(1, 2, 1), (2, 3, 2), (3, 1, 1)]


------------------------------------------------------------------
-- Aade un army al terreno x
------------------------------------------------------------------
place ((a, b, c):xs) x = if x == a then (a,b+1,c):xs else (a,b,c):place xs x
placemap = place [(1, 2, 1), (2, 3, 2), (3, 1, 1)]


------------------------------------------------------------------
-- Ataca el propietario own desde x a y. En el ataque se resta 1 a los armies de y, si da 0 es conquistado por own.
-- No se permite atacar desde un terreno que tenga menos de 2 armies. Los terrenos deben ser fronterizos.
------------------------------------------------------------------
attacksub [] x y own = []
attacksub ((a, b, c):xs) x y own = if x == a then (a,b-1,c):attacksub xs x y own else 
				if y == a then 
					if b-1 < 1 then (a,1,own):attacksub xs x y own else (a,b-1,c):attacksub xs x y own
				else (a,b,c):attacksub xs x y own


attack borders info x y own = if tisfront borders info x y == 1 && owner info x == own && armies info x > 1 then attacksub info x y own else info

attackmap = attack [(1, 2), (2, 3)] [(1, 2, 1), (2, 3, 2), (3, 1, 1)]


------------------------------------------------------------------
-- Jugador 1
------------------------------------------------------------------
placement1 borders info = place info (lessarmies info 1)
placementmap1 = placement1 [(1, 2), (2, 3)] [(1, 2, 1), (2, 3, 2), (3, 1, 1)]

attack1 borders info = attack borders info (morearmies info 1) (lessenemies info (morearmies info 1)) 1
attackmap1 = attack1 [(1, 2), (2, 3)] [(1, 2, 1), (2, 3, 2), (3, 1, 1)]


------------------------------------------------------------------
-- Jugador 2
------------------------------------------------------------------
placement2 borders info = place info (lessarmies info 2)
placementmap2 = placement2 [(1, 2), (2, 3)] [(1, 2, 1), (2, 3, 2), (3, 1, 1)]

attack2 borders info = attack borders info (morearmies info 2) (lessenemies info (morearmies info 2)) 2
attackmap2 = attack2 [(1, 2), (2, 3)] [(1, 2, 1), (2, 3, 2), (3, 1, 1)]


------------------------------------------------------------------
-- Realizamos 3 placements seguidos intercalando jugador 1 y 2
------------------------------------------------------------------
placementfor3 borders info = placement1 borders (placement2 borders  (placement1 borders (placement2 borders (placement1 borders (placement2 borders info)))))
placementfor3map = placementfor3 [(1, 2), (2, 3)] [(1, 2, 1), (2, 3, 2), (3, 1, 1)]


------------------------------------------------------------------
-- Realizamos 3 ataques seguidos intercalando jugador 1 y 2
------------------------------------------------------------------
attackfor3 borders info = attack1 borders (attack2 borders  (attack1 borders (attack2 borders (attack1 borders (attack2 borders info)))))
attackfor3map = attackfor3 [(1, 2), (2, 3)] [(1, 2, 1), (2, 3, 2), (3, 1, 1)]


------------------------------------------------------------------
-- MAIN: Juego
--
-- Info (Country, armies, owner): [(1, 2, 1), (2, 3, 2), (3, 1, 1)]
-- Borders (Country, Country): [(1, 2), (2, 3)]
------------------------------------------------------------------
mainsub borders info = attackfor3 borders (placementfor3 borders (attackfor3 borders (placementfor3 borders info)))
main = mainsub [(1, 2), (2, 3)] [(1, 2, 1), (2, 3, 2), (3, 1, 1)]

